<template>
    <div>
        <!-- breadcrumb start -->
        <div v-if="show==='cartMain'" class="breadcrumb-section">
            <div class="container">
                <div class="row">
                    <div class="col-sm-6">
                        <div class="page-title">
                            <h2>cart</h2>
                        </div>
                    </div>
                    <div class="col-sm-6">
                        <nav aria-label="breadcrumb" class="theme-breadcrumb">
                            <ol class="breadcrumb">
                                <li class="breadcrumb-item"><a href="/">Home</a></li>
                                <li class="breadcrumb-item active">cart</li>
                            </ol>
                        </nav>
                    </div>
                </div>
            </div>
        </div>
        <!-- breadcrumb End -->
        <!--section start-->
        <section v-if="show==='cartMain'" class="cart-section section-b-space">
            <div class="container">
                <div class="row">
                    <div class="col-sm-12">
                        <table class="table cart-table table-responsive-xs">
                            <thead>
                            <tr class="table-head">
                                <th scope="col">image</th>
                                <th scope="col">product name</th>
                                <th scope="col">price</th>
                                <th scope="col">quantity</th>
                                <th scope="col">action</th>
                                <th scope="col">total</th>
                            </tr>
                            </thead>
                            <tbody>
                                <tr v-for="(product,key) in products.content" :key="product.id">
                                <td>
                                    <a href="#"><img :src="'storage/product/'+product.attributes.image" alt=""></a>
                                </td>
                                <td><a href="#">{{product.name}}</a>
                                    <div class="mobile-cart-content row">
                                        <div class="col-xs-3">
                                            <div class="qty-box">
                                                <div class="input-group">
                                                    <input type="number" v-model.number="quantity[key]=product.quantity" @change="cartUpdate(product.id,key)" name="quantity" class="form-control"
                                                           />
                                                </div>
                                            </div>
                                        </div>
                                        <div class="col-xs-3">
                                            <h2 class="td-color">${{product.price}}</h2>
                                        </div>
                                        <div class="col-xs-3">
                                            <h2 class="td-color"><a href="javascript:void(0)" @click="removeCart(product.id)" class="icon"><i class="ti-close"></i></a>
                                            </h2>
                                        </div>
                                    </div>
                                </td>
                                <td>
                                    <h2>${{product.price}}</h2>
                                </td>
                                <td>
                                    <div class="qty-box">
                                        <div class="input-group">
                                            <input type="number" v-model.number="quantity[key]=product.quantity" @change="cartUpdate(product.id,key)" name="quantity" class="form-control"
                                                   />
                                        </div>
                                    </div>
                                </td>
                                <td><a href="javascript:void(0)" @click="removeCart(product.id)" class="icon"><i class="ti-close"></i></a></td>
                                <td>
                                    <h2 class="td-color">${{product.price *product.quantity}}</h2>
                                </td>
                            </tr>
                            </tbody>
                        </table>
                        <table class="table cart-table table-responsive-md">
                            <tfoot>
                            <tr>
                                <td>total price :</td>
                                <td>
                                    <h2>${{products.total}}</h2>
                                </td>
                            </tr>
                            </tfoot>
                        </table>
                    </div>
                </div>
                <div class="row cart-buttons">
                    <div class="col-6">
                        <a href="javascript:void(0)" class="btn btn-solid">continue shopping</a>
                    </div>
                    <div class="col-6">
                        <a href="javascript:void(0)" @click="pageChange" class="btn btn-solid">check out</a>
                    </div>
                </div>
            </div>
        </section>
        <!--section end-->
        <Checkout v-else-if="show==='checkout'" :products="products"></Checkout>
    </div>

</template>

<script>
    import {EventBus} from "./event-bus";
    import Checkout from "./Checkout";
    export default {
        data(){
            return{
                products:{
                    type:Object,
                },
                quantity:[],
                show:"cartMain"
            }
        },
        created(){
            this.getCart();
        },
        methods:{
            getCart(){
                axios.get('/product/get/cart/info').then((response)=>{
                    this.products=response.data;
                });
            },
            cartUpdate(product,key){
                if (parseInt(this.quantity[key]) <=0){
                    alert('Invalid Request');
                    this.getCart();
                }else{
                    axios.get(`/product/update/${product}/cart${this.quantity[key]}`).then((response)=>{
                        //alert(response.data);
                        this.products=response.data;
                    });
                }

            },
            removeCart(id){
                axios.get(`product/cart/remove${id}`).then((response)=>{
                    this.products=response.data;
                });
            },
            pageChange(){
                /*enable when checkout is active*/
                this.$toaster.error('This fetcher is not enable');
                //this.show='checkout';
            }
        },
        components:{Checkout}
    }
</script>
